## CoalesceImages

CoalesceImages() composites a set of images while respecting any page offsets and disposal methods. GIF, MIFF, and MNG animation sequences typically start with an image background and each subsequent image varies in size and offset. A new image sequence is returned with all images the same size as the first and composited with the next image in the sequence.

The format of the CoalesceImages method is:

      Image *CoalesceImages(Image *image,ExceptionInfo *exception)

A description of each parameter follows:

##### image

The image sequence.

##### exception

Return any errors or warnings in this structure.

## DisposeImages

DisposeImages() returns the coalesced frames of a GIF animation as it would appear after the GIF dispose method of that frame has been applied. That is it returned the appearance of each frame before the next is overlaid.

The format of the DisposeImages method is:

      Image *DisposeImages(Image *image,ExceptionInfo *exception)

A description of each parameter follows:

##### image

The image sequence.

##### exception

Return any errors or warnings in this structure.

## CompareImageLayers

CompareImageLayers() compares each image with the next in a sequence and returns the minimum bounding region of all the pixel differences (of the LayerType specified) it discovers.

Images do NOT have to be the same size, though it is best that all the images are 'coalesced' (images are all the same size, on a flattened canvas, so as to represent exactly how an specific frame should look).

No GIF dispose methods are applied, so GIF animations must be coalesced before applying this image operator to find differences to them.

The format of the CompareImageLayers method is:

      Image *CompareImageLayers(const Image *images,
        const MagickLayerMethod method,ExceptionInfo *exception)

A description of each parameter follows:

##### image

The image.

##### method

The layers type to compare images with. Must be one of... CompareAnyLayer, CompareClearLayer, CompareOverlayLayer.

##### exception

Return any errors or warnings in this structure.

## DeconstructImages

DeconstructImages() compares each image with the next in a sequence and returns the minimum bounding region of all differences from the first image.

This function is depreciated in favor of the more universal CompareImageLayers() function.

The format of the DeconstructImages method is:

      Image *DeconstructImages(const Image *images, ExceptionInfo *exception)

A description of each parameter follows:

##### image

The image.

##### exception

Return any errors or warnings in this structure.

## OptimizeImageLayers

OptimizeImageLayers() compares each image the GIF disposed forms of the previous image in the sequence. From this it attempts to select the smallest cropped image to replace each frame, while preserving the results of the GIF animation.

The format of the OptimizeImageLayers method is:

      Image *OptimizeImageLayers(const Image *image,
               ExceptionInfo *exception)

A description of each parameter follows:

##### image

The image.

##### exception

Return any errors or warnings in this structure.

## OptimizeImagePlusLayers

OptimizeImagePlusLayers() is exactly as OptimizeImageLayers(), but may also add or even remove extra frames in the animation, if it improves the total number of pixels in the resulting GIF animation.

The format of the OptimizePlusImageLayers method is:

      Image *OptimizePlusImageLayers(const Image *image,
               ExceptionInfo *exception)

A description of each parameter follows:

##### image

The image.

##### exception

Return any errors or warnings in this structure.

## OptimizeImageTransparency

OptimizeImageTransparency() takes a frame optimized GIF animation, and compares the overlayed pixels against the disposal image resulting from all the previous frames in the animation. Any pixel that does not change the disposal image (and thus does not effect the outcome of an overlay) is made transparent.

WARNING: This modifies the current images directly, rather than generate a new image sequence.

The format of the OptimizeImageTransperency method is:

      void OptimizeImageTransperency(Image *image,ExceptionInfo *exception)

A description of each parameter follows:

##### image

The image sequence

##### exception

Return any errors or warnings in this structure.

## RemoveDuplicateLayers

RemoveDuplicateLayers() removes any image that is exactly the same as the next image in the given image list. Image size and virtual canvas offset must also match, though not the virtual canvas size itself.

No check is made with regards to image disposal setting, though it is the dispose setting of later image that is kept. Also any time delays are also added together. As such coalesced image animations should still produce the same result, though with duplicte frames merged into a single frame.

The format of the RemoveDuplicateLayers method is:

      void RemoveDuplicateLayers(Image **image, ExceptionInfo *exception)

A description of each parameter follows:

##### images

The image list

##### exception

Return any errors or warnings in this structure.

## RemoveZeroDelayLayers

RemoveZeroDelayLayers() removes any image that as a zero delay time. Such images generally represent intermediate or partial updates in GIF animations used for file optimization. They are not ment to be displayed to users of the animation. Viewable images in an animation should have a time delay of 3 or more centi-seconds (hundredths of a second).

However if all the frames have a zero time delay, then either the animation is as yet incomplete, or it is not a GIF animation. This is a non-sensible situation, so no image will be removed and a 'Zero Time Animation' warning (exception) given.

No warning will be given if no image was removed because all images had an appropriate non-zero time delay set.

Due to the special requirements of GIF disposal handling, GIF animations should be coalesced first, before calling this function, though that is not a requirement.

The format of the RemoveZeroDelayLayers method is:

      void RemoveZeroDelayLayers(Image **image, ExceptionInfo *exception)

A description of each parameter follows:

##### images

The image list

##### exception

Return any errors or warnings in this structure.

## CompositeLayers

CompositeLayers() compose first image sequence (source) over the second image sequence (destination), using the given compose method and offsets.

The pointers to the image list does not have to be the start of that image list, but may start somewhere in the middle. Each layer from the two image lists are composted together until the end of one of the image lists is reached. The offset of each composition is also adjusted to match the virtual canvas offsets of each layer. As such the given offset is relative to the virtual canvas, and not the actual image.

No GIF disposal handling is performed, so GIF animations should be coalesced before use. However this is not a requirement, and individual layer images may have any size or offset, for special compositions.

Special case:- If one of the image sequences is just a single image that image is repeatally composed with all the images in the other image list. Either the source or destination lists may be the single image, for this situation.

The destination list will be expanded as needed to match number of source image overlaid (from current position to end of list).

The format of the CompositeLayers method is:

      void CompositeLayers(Image *destination,
          const CompositeOperator compose, Image *source,
          const long x_offset, const long y_offset,
          ExceptionInfo *exception);

A description of each parameter follows:

##### destination

the destination images and results

##### source

source image(s) for the layer composition

##### compose, x_offset, y_offset

arguments passed on to CompositeImages()

##### exception

Return any errors or warnings in this structure.

Discourse Server • Mailing Lists • ImageMagick Studio